# Go API client for ubiquity

Ubiquity provides a RESTful and uniform way to access blockchain resources,
with a rich and reusable model across multiple cryptocurrencies.

[Documentation](https://app.blockdaemon.com/docs/ubiquity)

### Protocols
#### Mainnet
The following protocols are currently supported:
* bitcoin
* ethereum
* polkadot
* xrp
* algorand
* stellar
* dogecoin
* oasis
* near
* terra
* litecoin
* bitcoincash
* tezos

#### Testnet
* bitcoin/testnet
* ethereum/ropsten
* dogecoin/testnet
* litecoin/testnet
* bitcoincash/testnet

#### Native
Ubiquity provides native access to all Blockchain nodes it supports.
* bitcoin/(mainnet | testnet) - [RPC Documentation](https://developer.bitcoin.org/reference/rpc/)
* ethereum/(mainnet | ropsten) - [RPC Documentation](https://ethereum.org/en/developers/docs/apis/json-rpc/)
* polkadot/mainnet - [Sidecar API Documentation](https://paritytech.github.io/substrate-api-sidecar/dist/)
* polkadot/mainnet/http-rpc - [Polkadot RPC Documentation](https://polkadot.js.org/docs/substrate/rpc/)
* algorand/mainnet - [Algod API Documentation](https://developer.algorand.org/docs/reference/rest-apis/algod/)
* stellar/mainnet - [Stellar Horizon API Documentation](https://developers.stellar.org/api)
* dogecoin/(mainnet | testnet) - [Dogecoin API Documentaion](https://developer.bitcoin.org/reference/rpc/)
* oasis/mainnet - [Oasis Rosetta Gateway Documentation](https://www.rosetta-api.org/docs/api_identifiers.html#network-identifier)
* near/mainnet - [NEAR RPC Documentation](https://docs.near.org/docs/api/rpc)
* terra/mainnet - [Terra RPC Documentation](https://docs.terra.money/docs/develop/how-to/endpoints.html)
* litecoin/mainnet - [Litecoin RPC Documentation](https://litecoin.info/index.php/Litecoin_API)
* bitcoincash/mainnet - [Bitcoin Cash RPC Documentation](https://docs.bitcoincashnode.org/doc/json-rpc/)
* tezos/mainnet - [Tezos RPC Documentation](https://tezos.gitlab.io/developer/rpc.html)


A full URL example: https://ubiquity.api.blockdaemon.com/v1/bitcoin/mainnet

##### Pagination
Certain resources contain a lot of data, more than what's practical
to return for a single request.
With the help of pagination, the data is split across multiple responses.
Each response returns a subset of the items requested, and a continuation token.

To get the next batch of items, copy the returned continuation token
to the continuation query parameter and repeat the request with the new URL.
In case no continuation token is returned, there is no more data available.


## Overview
This API client was generated by the [OpenAPI Generator](https://openapi-generator.tech) project.  By using the [OpenAPI-spec](https://www.openapis.org/) from a remote server, you can easily generate an API client.

- API version: 3.0.0
- Package version: 1.0.0
- Build package: org.openapitools.codegen.languages.GoClientCodegen
For more information, please visit [https://blockdaemon.com](https://blockdaemon.com)

## Installation

Install the following dependencies:

```shell
go get github.com/stretchr/testify/assert
go get golang.org/x/oauth2
go get golang.org/x/net/context
```

Put the package under your project folder and add the following in import:

```golang
import sw "./ubiquity"
```

To use a proxy, set the environment variable `HTTP_PROXY`:

```golang
os.Setenv("HTTP_PROXY", "http://proxy_name:proxy_port")
```

## Configuration of Server URL

Default configuration comes with `Servers` field that contains server objects as defined in the OpenAPI specification.

### Select Server Configuration

For using other server than the one defined on index 0 set context value `sw.ContextServerIndex` of type `int`.

```golang
ctx := context.WithValue(context.Background(), sw.ContextServerIndex, 1)
```

### Templated Server URL

Templated server URL is formatted using default variables from configuration or from context value `sw.ContextServerVariables` of type `map[string]string`.

```golang
ctx := context.WithValue(context.Background(), sw.ContextServerVariables, map[string]string{
	"basePath": "v2",
})
```

Note, enum values are always validated and all unused variables are silently ignored.

### URLs Configuration per Operation

Each operation can use different server URL defined using `OperationServers` map in the `Configuration`.
An operation is uniquely identifield by `"{classname}Service.{nickname}"` string.
Similar rules for overriding default operation server index and variables applies by using `sw.ContextOperationServerIndices` and `sw.ContextOperationServerVariables` context maps.

```
ctx := context.WithValue(context.Background(), sw.ContextOperationServerIndices, map[string]int{
	"{classname}Service.{nickname}": 2,
})
ctx = context.WithValue(context.Background(), sw.ContextOperationServerVariables, map[string]map[string]string{
	"{classname}Service.{nickname}": {
		"port": "8443",
	},
})
```

## Documentation for API Endpoints

All URIs are relative to *https://ubiquity.api.blockdaemon.com/v1*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*AccountsAPI* | [**GetListOfBalancesByAddress**](docs/AccountsAPI.md#getlistofbalancesbyaddress) | **Get** /{platform}/{network}/account/{address} | Balances Of Address
*AccountsAPI* | [**GetListOfBalancesByAddresses**](docs/AccountsAPI.md#getlistofbalancesbyaddresses) | **Post** /{platform}/{network}/accounts | Balances Of Addresses
*AccountsAPI* | [**GetReportByAddress**](docs/AccountsAPI.md#getreportbyaddress) | **Get** /{platform}/{network}/account/{address}/report | A financial report for an address between a time period. Default timescale is within the last 30 days
*AccountsAPI* | [**GetTxsByAddress**](docs/AccountsAPI.md#gettxsbyaddress) | **Get** /{platform}/{network}/account/{address}/txs | Transactions Of Address
*BlocksAPI* | [**GetBlock**](docs/BlocksAPI.md#getblock) | **Get** /{platform}/{network}/block/{key} | Block By Number/Hash
*BlocksAPI* | [**GetBlockIdentifier**](docs/BlocksAPI.md#getblockidentifier) | **Get** /{platform}/{network}/block_identifier/{key} | Block Identifier By Number/Hash
*BlocksAPI* | [**GetBlockIdentifiers**](docs/BlocksAPI.md#getblockidentifiers) | **Get** /{platform}/{network}/block_identifiers | Block Identifiers
*NFTAPI* | [**ExplorerGetCollection**](docs/NFTAPI.md#explorergetcollection) | **Get** /nft/{protocol}/{network}/collection/{id} | 
*NFTAPI* | [**ExplorerListAssets**](docs/NFTAPI.md#explorerlistassets) | **Get** /nft/{protocol}/{network}/assets | 
*NFTAPI* | [**ExplorerListCollections**](docs/NFTAPI.md#explorerlistcollections) | **Get** /nft/{protocol}/{network}/collections | 
*NFTAPI* | [**ExplorerListEvents**](docs/NFTAPI.md#explorerlistevents) | **Get** /nft/{protocol}/{network}/events | 
*PlatformsAPI* | [**GetPlatformEndpoints**](docs/PlatformsAPI.md#getplatformendpoints) | **Get** /{platform}/{network}/ | Platform Info
*PlatformsAPI* | [**GetPlatformsList**](docs/PlatformsAPI.md#getplatformslist) | **Get** / | Platforms overview
*SyncAPI* | [**CurrentBlockID**](docs/SyncAPI.md#currentblockid) | **Get** /{platform}/{network}/sync/block_id | Get current block ID
*SyncAPI* | [**CurrentBlockNumber**](docs/SyncAPI.md#currentblocknumber) | **Get** /{platform}/{network}/sync/block_number | Get current block number
*TransactionsAPI* | [**FeeEstimate**](docs/TransactionsAPI.md#feeestimate) | **Get** /{platform}/{network}/tx/estimate_fee | Get fee estimate
*TransactionsAPI* | [**GetTx**](docs/TransactionsAPI.md#gettx) | **Get** /{platform}/{network}/tx/{id} | Transaction By Hash
*TransactionsAPI* | [**GetTxConfirmations**](docs/TransactionsAPI.md#gettxconfirmations) | **Get** /{platform}/{network}/tx/{id}/confirmations | Transaction confirmations By Hash
*TransactionsAPI* | [**GetTxs**](docs/TransactionsAPI.md#gettxs) | **Get** /{platform}/{network}/txs | Latest transactions of a protocol
*TransactionsAPI* | [**TxSend**](docs/TransactionsAPI.md#txsend) | **Post** /{platform}/{network}/tx/send | Submit a signed transaction


## Documentation For Models

 - [AccountsObj](docs/AccountsObj.md)
 - [AlgorandMeta](docs/AlgorandMeta.md)
 - [Asset](docs/Asset.md)
 - [AssetTrait](docs/AssetTrait.md)
 - [AssetWallet](docs/AssetWallet.md)
 - [Balance](docs/Balance.md)
 - [Block](docs/Block.md)
 - [BlockIdentifier](docs/BlockIdentifier.md)
 - [BlockIdentifierPage](docs/BlockIdentifierPage.md)
 - [Collection](docs/Collection.md)
 - [Contract](docs/Contract.md)
 - [Currency](docs/Currency.md)
 - [Event](docs/Event.md)
 - [FeeEstimate](docs/FeeEstimate.md)
 - [FeeEstimateEstimatedFees](docs/FeeEstimateEstimatedFees.md)
 - [GetCollectionResponse](docs/GetCollectionResponse.md)
 - [ListAssetsResponse](docs/ListAssetsResponse.md)
 - [ListCollectionResponse](docs/ListCollectionResponse.md)
 - [ListEventResponse](docs/ListEventResponse.md)
 - [Meta](docs/Meta.md)
 - [ModelError](docs/ModelError.md)
 - [NFTEvent](docs/NFTEvent.md)
 - [NativeCurrency](docs/NativeCurrency.md)
 - [Paging](docs/Paging.md)
 - [PlatformDetail](docs/PlatformDetail.md)
 - [PlatformsOverview](docs/PlatformsOverview.md)
 - [PlatformsOverviewPlatforms](docs/PlatformsOverviewPlatforms.md)
 - [Report](docs/Report.md)
 - [ReportField](docs/ReportField.md)
 - [ReportFieldMeta](docs/ReportFieldMeta.md)
 - [SignedTx](docs/SignedTx.md)
 - [SmartToken](docs/SmartToken.md)
 - [SmartTokenCurrency](docs/SmartTokenCurrency.md)
 - [Token](docs/Token.md)
 - [TokenCurrency](docs/TokenCurrency.md)
 - [Tx](docs/Tx.md)
 - [TxConfirmation](docs/TxConfirmation.md)
 - [TxPage](docs/TxPage.md)
 - [TxReceipt](docs/TxReceipt.md)


## Documentation For Authorization



### apiKeyAuth

- **Type**: API key
- **API key parameter name**: apiKey
- **Location**: URL query string

Note, each API key must be added to a map of `map[string]APIKey` where the key is: apiKey and passed in as the auth context for each request.


### bearerAuth

- **Type**: HTTP Bearer token authentication

Example

```golang
auth := context.WithValue(context.Background(), sw.ContextAccessToken, "BEARERTOKENSTRING")
r, err := client.Service.Operation(auth, args)
```


## Documentation for Utility Methods

Due to the fact that model structure members are all pointers, this package contains
a number of utility functions to easily obtain pointers to values of basic types.
Each of these functions takes a value of the given basic type and returns a pointer to it:

* `PtrBool`
* `PtrInt`
* `PtrInt32`
* `PtrInt64`
* `PtrFloat`
* `PtrFloat32`
* `PtrFloat64`
* `PtrString`
* `PtrTime`

## Author

support@blockdaemon.com

